#!/bin/bash
###################################################
kernel_rel=$1
arch=`uname -m`
function get_distro_ver()
{
	set -x	
	local major=""
	local minor=""
	local rhel_ver=""
	local index="0"
	local sles_ver=""
	local isxen=""
	local isddk=""
	local release=""
	local sub_release=""
	if [ -f /etc/redhat-release ]; then
		isxen=$(cat /etc/redhat-release | cut -f 1 -d " ")
		isddk=$(cat /etc/redhat-release | cut -f 2 -d " ")
		release=$(cat /etc/redhat-release | cut -f 4 -d " " | cut -f 2 -d ".")
		if [ "$isxen" == "XenServer" ] && [ "$isddk" == "DDK" ]; then
			sub_release=$(cat /etc/redhat-release | cut -f 4 -d " " | cut -f 3 -d "." | cut -f 1 -d "-")
			release=$release.${sub_release}
			case "$release" in
				6.0) index="9";;
				6.100) index="11";;
				*) ;;
			esac

        	elif [ -f /lib/modules/$kernel_rel/build/include/linux/version.h ]; then
			major=`cat  /lib/modules/${kernel_rel}/build/include/linux/version.h \
							| grep RHEL_MAJOR | cut -d ' ' -f 3`
			minor=`cat  /lib/modules/${kernel_rel}/build/include/linux/version.h \
							| grep RHEL_MINOR | cut -d ' ' -f 3`
	
		rhel_ver=rhel$major.$minor
		case "$rhel_ver" in
  		    rhel5.4) index="4";;
  		    rhel5.5) index="5";;
  		    rhel6.0) index="10";;
  		    rhel5.6) index="12";;
    		     *);;
	        esac		

		elif [ -f /usr/src/kernels/$kernel_rel[.-]$arch/include/linux/version.h ]; then
			major=`cat  /usr/src/kernels/$kernel_rel[.-]$arch/include/linux/version.h \
                                                        | grep RHEL_MAJOR | cut -d ' ' -f 3`
                        minor=`cat  /usr/src/kernels/$kernel_rel[.-]$arch/include/linux/version.h \
                                                        | grep RHEL_MINOR | cut -d ' ' -f 3`
		rhel_ver=rhel$major.$minor
                case "$rhel_ver" in
                    rhel5.4) index="4";;
                    rhel5.5) index="5";;
                    rhel6.0) index="10";;
                    rhel5.6) index="12";;
                     *);;
                esac

		fi
        elif [ -f /etc/SuSE-release ]; then

                major=(`cat  /etc/SuSE-release|grep VERSION | sed -e 's/.*= //'`)
                minor=(`cat  /etc/SuSE-release|grep PATCH | sed -e 's/.*= //'`)
                if [  ${minor} == "0" ]; then
                        sles_ver=sles$major
                else
                        sles_ver=sles${major}sp${minor}
                fi
		
		case "$sles_ver" in
                    sles10sp3) index="6";;
                    sles11) index="7";;
                    sles11sp1) index="8";;
                    sles10sp4) index="13";;
                     *);;
                esac

        fi
	echo $index
}
set -x
get_distro_ver
