%define driver_name  qlcnic
%define driver_version  5.0.15.2
%define driver_vendor  hp
%define vendor_url www.hp.com
%define vendor_cmpny Hewlett Packard

%define release	2
%define hostversion %{driver_version}
%define kmod_vendor %{driver_vendor}
%define kmod_name %{driver_name}
%define kmod_full_name %{kmod_vendor}-%{kmod_name}

Name: %{kmod_full_name}
Version: %{driver_version}
Release: %{release}
Group: System Environment/Kernel
Vendor: %{vendor_cmpny}
Packager: %{vendor_cmpny}
License: GPL
Source0: get_release.sh
Source1: nxdebug
Source2: README_nxdebug
Source3: qlcnic.4.gz
Source4: %{driver_name}-src-%{driver_version}_rhel5.4.tar.gz
Source5: %{driver_name}-src-%{driver_version}_rhel5.5.tar.gz
Source6: %{driver_name}-src-%{driver_version}_sles10sp3.tar.gz
Source7: %{driver_name}-src-%{driver_version}_sles11.tar.gz
Source8: %{driver_name}-src-%{driver_version}_sles11sp1.tar.gz
Source9: %{driver_name}-src-%{driver_version}_xs5.6.tar.gz
Source10: %{driver_name}-src-%{driver_version}_rhel6.tar.gz
Source11: %{driver_name}-src-%{driver_version}_xs5.6fp1.tar.gz
Source12: %{driver_name}-src-%{driver_version}_rhel5.6.tar.gz
Source13: %{driver_name}-src-%{driver_version}_sles10sp4.tar.gz

URL: %{vendor_url}
Buildroot: %{_tmppath}/%{name}-%{version}/bldroot
Summary: QLogic driver for Ethernet Adapter.

%define packinfo "This package contains Qlogic driver for Ethernet Adapter"
%define debug_package %{nil}

%if "%{_vendor}" == "redhat"
%define whatos %(echo `cat /etc/redhat-release | cut -f 1 -d " "`)
%define isddk %(echo `cat /etc/redhat-release | cut -f 2 -d " "`)
%endif

%define xen_srvr 0
%if "%{whatos}" == "XenServer"
%if "%{isddk}" == "DDK"
%define xen_srvr 1
%define kverrel %(echo %{kernel_version} )
%define flavors_to_build %{flavour}
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define custom 1
%else
%define custom 0
%endif

%if "%{_host_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav debug default kdump smp xen trace
%else
%define flav bigsmp debug default kdump kdumpae smp vmi vmipae xen xenpae pae trace
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%define kverrel %(echo %{KVER} | awk -F"-" '{print $1"-"$2}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%define rhel_version %(cat /etc/redhat-release | grep "Red Hat Enterprise" | cut -d " " -f 7)

%if %{!?KVER:0}%{?KVER:1}
%global kernel_version %{KVER}
%if "%{rhel_version}" == "6.0"
%define flav %(echo %{kernel_version} | awk -F"el6" '{print $2}' | awk -F"." '{print $3')
%else
%define flav %(echo %{kernel_version} | awk -F"el5" '{print $2}')
%endif

%if "%{flav}" == ""
%define flav default
%endif
%endif

%if %{!?KVER:1}%{?KVER:0}
%{!?kernel_version: %global kernel_version %( if [ -z "${KERNEL}" ]; then ( echo "`uname -r`"); else ( echo "${KERNEL}"); fi )}
%define flav ""
%endif
%endif

%description
%{packinfo}

%if "%{xen_srvr}" == "1"
%package %{flavour}
summary: QLogic driver for NIC
Group: System/kernel

%description %{flavour}
%{packinfo}
%endif

%package tools
Summary: QLogic user components for Linux driver
Group: System/Kernel

%description tools
Stuff for the QLogic Ethernet Kernel Module.

%if "%{_host_vendor}" == "suse"
BuildRequires: kernel-source kernel-syms
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav}

%package KMP
summary: QLogic Ethernet Driver
Group: System/kernel

%description KMP
%{packinfo}

%else
%if "%{xen_srvr}" == "0"
BuildRequires: %kernel_module_package_buildreqs
%{kernel_module_package %flav}
%endif
%endif


%if %{custom}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif


%prep
%define index %(bash %{SOURCE0} %{kernel_version})

%if %{index}
%setup -T -b %{index} -n  %{driver_name}-%{driver_version}
%else
echo "This build is Not supported"
exit 1
%endif


set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
echo %{flavors}
export EXTRA_CFLAGS='-DVERSION=\"%version\"'

for flavor in %{flavors}; do
%define compile_with %{kernel_source $flavor}
%if "%{xen_srvr}" == "1"
%define compile_with /lib/modules/%{kverrel}$flavor/build/
%endif

rm -rf obj/$flavor
cp -r source obj/$flavor
make -C %{compile_with} modules M=$PWD/obj/$flavor CONFIG_QLCNIC=m
done

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{name}
if [ "%{_host_vendor}" == "suse" ]; then
export INSTALL_MOD_DIR=updates/%{name}
fi
for flavor in %{flavors}; do
make  -C %{compile_with} modules_install M=$PWD/obj/$flavor
done
mkdir -p $RPM_BUILD_ROOT/opt/qlcnic/
install -D -m 755 %{SOURCE1} $RPM_BUILD_ROOT/opt/qlcnic/
install -D -m 755 %{SOURCE2} $RPM_BUILD_ROOT/opt/qlcnic
install -D -m 644 %{SOURCE3} $RPM_BUILD_ROOT/%{_mandir}/man4/qlcnic.4.gz

%clean
rm -rf %{buildroot}

%if "%{xen_srvr}" == "1"
%files %{flavour}
%defattr(-, root, root)
%attr(644,root,root) /lib/modules/%{kverrel}%{flavour}/extra/%{name}/qlcnic.ko
%endif

%if "%{xen_srvr}" == "1"
%post  %{flavour}
depmod %{kernel_version}%{flavour}

%postun  %{flavour}
depmod %{kernel_version}%{flavour}
%endif

%files tools
%defattr(-, root, root)
%{_mandir}/man4/qlcnic.4.gz
%attr(755,root,root) /opt/qlcnic/nxdebug
%attr(755,root,root) /opt/qlcnic/README_nxdebug


%define major_change (Severity:Critical)
%define medium_change (Severity:Medium)
%define minor_change (Severity:Minor)

%changelog 

* Thu Feb 03 2011 Rajesh Borundia <rajesh.borundia@qlogic.com> 
- First Release 
